
#ifndef PROFILER_IDS_H

#ifdef PROFILER_ON

#include <stdint.h>

typedef enum profiler_timeline_id_t {
    profiler_timeline_id_worker_thread,
    profiler_timeline_id_main,
    profiler_timeline_id_count
} profiler_timeline_id_t;

typedef enum profiler_event_id_t {
    profiler_event_id_profiler_collapse,
    profiler_event_id_profiler_not_measured,
    profiler_event_id_atlas_create,
    profiler_event_id_x,
    profiler_event_id_char_is_any_u32,
    profiler_event_id_date_to_string,
    profiler_event_id_gl_batch_rectangle,
    profiler_event_id_gl_update_texture_content,
    profiler_event_id_http_file_open,
    profiler_event_id_http_file_get,
    profiler_event_id_image_resize,
    profiler_event_id_image_to_ascii_render,
    profiler_event_id_extra_step,
    profiler_event_id_layout_text,
    profiler_event_id_layout_get_single_line_size,
    profiler_event_id_layout_get_byte_at_position,
    profiler_event_id_layout_fit_single_line,
    profiler_event_id_push_string,
    profiler_event_id_layout_end,
    profiler_event_id_layout_single_line,
    profiler_event_id_layout_pass_end,
    profiler_event_id_layout_pass_start,
    profiler_event_id_thread_do_work,
    profiler_event_id_thread_user_function,
    profiler_event_id_thread_queue_completed_signal,
    profiler_event_id_thread_loop,
    profiler_event_id_thread_wait_for_work,
    profiler_event_id_thread_queue_terminated_signal,
    profiler_event_id_thread_queue_work,
    profiler_event_id_thread_queue_signal,
    profiler_event_id_thread_complete_queue,
    profiler_event_id_thread_wait_for_completion,
    profiler_event_id_thread_terminate,
    profiler_event_id_thread_terminate_signal,
    profiler_event_id_thread_wait_for_termination,
    profiler_event_id_input_sync_keys,
    profiler_event_id_window_proc,
    profiler_event_id_default_window_proc,
    profiler_event_id_window_create,
    profiler_event_id_register_class_w,
    profiler_event_id_dummy_create_window_ex_w,
    profiler_event_id_dummy_choose_pixel_format,
    profiler_event_id_dummy_describe_pixel_format,
    profiler_event_id_dummy_set_pixel_format,
    profiler_event_id_dummy_wgl_create_context,
    profiler_event_id_dummy_wgl_make_current,
    profiler_event_id_dummy_get_wgl_functions,
    profiler_event_id_dummy_get_gl_functions,
    profiler_event_id_log_functions,
    profiler_event_id_create_window_ex_w,
    profiler_event_id_wgl_choose_pixel_format,
    profiler_event_id_describe_pixel_format,
    profiler_event_id_set_pixel_format,
    profiler_event_id_wgl_create_context_attribs,
    profiler_event_id_wgl_make_current,
    profiler_event_id_show_window,
    profiler_event_id_register_raw_input_devices,
    profiler_event_id_window_handle_messages,
    profiler_event_id_setup,
    profiler_event_id_GetMessage,
    profiler_event_id_PeekMessage,
    profiler_event_id_loop,
    profiler_event_id_default_translate,
    profiler_event_id_default_dispatch,
    profiler_event_id_window_swap_buffers,
    profiler_event_id_render_clear,
    profiler_event_id_render_texture_rgba,
    profiler_event_id_frame_loop,
    profiler_event_id_resize,
    profiler_event_id_to_grayscale,
    profiler_event_id_batch_characters,
    profiler_event_id_render,
    profiler_event_id_count
} profiler_event_id_t;

#ifdef PROFILER_IMPLEMENTATION

const char* profiler_timeline_id_strings[ profiler_timeline_id_count ] = {
    "worker_thread",
    "main",
};

uint16_t profiler_timeline_id_string_lengths[ profiler_timeline_id_count ] = {
    13, 4, 
};

uint16_t profiler_max_timeline_id_string_length = 13;

const char* profiler_event_id_strings[ profiler_event_id_count ] = {
    "profiler_collapse",
    "profiler_not_measured",
    "atlas_create",
    "x",
    "char_is_any_u32",
    "date_to_string",
    "gl_batch_rectangle",
    "gl_update_texture_content",
    "http_file_open",
    "http_file_get",
    "image_resize",
    "image_to_ascii_render",
    "extra_step",
    "layout_text",
    "layout_get_single_line_size",
    "layout_get_byte_at_position",
    "layout_fit_single_line",
    "push_string",
    "layout_end",
    "layout_single_line",
    "layout_pass_end",
    "layout_pass_start",
    "thread_do_work",
    "thread_user_function",
    "thread_queue_completed_signal",
    "thread_loop",
    "thread_wait_for_work",
    "thread_queue_terminated_signal",
    "thread_queue_work",
    "thread_queue_signal",
    "thread_complete_queue",
    "thread_wait_for_completion",
    "thread_terminate",
    "thread_terminate_signal",
    "thread_wait_for_termination",
    "input_sync_keys",
    "window_proc",
    "default_window_proc",
    "window_create",
    "register_class_w",
    "dummy_create_window_ex_w",
    "dummy_choose_pixel_format",
    "dummy_describe_pixel_format",
    "dummy_set_pixel_format",
    "dummy_wgl_create_context",
    "dummy_wgl_make_current",
    "dummy_get_wgl_functions",
    "dummy_get_gl_functions",
    "log_functions",
    "create_window_ex_w",
    "wgl_choose_pixel_format",
    "describe_pixel_format",
    "set_pixel_format",
    "wgl_create_context_attribs",
    "wgl_make_current",
    "show_window",
    "register_raw_input_devices",
    "window_handle_messages",
    "setup",
    "GetMessage",
    "PeekMessage",
    "loop",
    "default_translate",
    "default_dispatch",
    "window_swap_buffers",
    "render_clear",
    "render_texture_rgba",
    "frame_loop",
    "resize",
    "to_grayscale",
    "batch_characters",
    "render",
};

uint16_t profiler_event_id_string_lengths[ profiler_event_id_count ] = {
    17,
    21,
    12, 1, 15, 14, 18, 25, 14, 13, 12, 21, 10, 11, 27, 27, 22, 11, 10, 18,
    15, 17, 14, 20, 29, 11, 20, 30, 17, 19, 21, 26, 16, 23, 27, 15, 11, 19, 13, 16,
    24, 25, 27, 22, 24, 22, 23, 22, 13, 18, 23, 21, 16, 26, 16, 11, 26, 22,
    5, 10, 11, 4, 17, 16, 19, 12, 19, 10, 6, 12, 16, 6, 
};

uint16_t profiler_max_event_id_string_length = 30;

#else /* PROFILER_IMPLEMENTATION */ 

extern const char* profiler_timeline_id_strings[ profiler_timeline_id_count ];
extern uint16_t profiler_timeline_id_string_lengths[ profiler_timeline_id_count ];
extern uint16_t profiler_max_timeline_id_string_length;
extern const char* profiler_event_id_strings[ profiler_event_id_count ];
extern uint16_t profiler_event_id_string_lengths[ profiler_event_id_count ];
extern uint16_t profiler_max_event_id_string_length;

#endif /* PROFILER_IMPLEMENTATION */ 

#endif /* PROFILER_ON */

#define PROFILER_IDS_H
#endif
